<p class="lang-links" style="text-align: right;">
    <a href="/ru">ru</a> | <span class="active-lang">en</span>
</p>
<img class="tvl-logo" src="https://static.tvl.su/latest/logo-animated.svg"
     alt="Virus with lambda-shaped spike proteins sitting on an armchair">

----------------

Welcome to the website of TVL LLC, the corporate face of the [**TVL**][tvl] Community.
We are a technology company headquartered in Moscow, working with a variety of topics:

* <details><summary><b>Monorepos</b>. Effective ways for an organisation to
  structure their internal codebase in a single repository, unify tooling across
  languages, and reduce <a
  href="https://en.wikipedia.org/wiki/No_Silver_Bullet#Summary">accidental
  complexity</a> in software development.</summary>

  With experience from companies like Google, Spotify and DeepMind, we help
  organisations of different sizes to find streamlined software development
  workflows that reduce mental load and increase code quality.

  We use our own monorepo solutions in our internal software development flows,
  and all of this is visible in our [public monorepo][depot].
  </details>
* <details><summary><b>Nix</b>. We believe that functional and declarative
  computer systems are a massive and as-of-yet underrated step forward for
  computing, and that Nix is the most promising solution for this
  purpose.</summary>

  Nix allows companies to significantly improve in areas such as:

  1. Unification of development and production environments, leading to fewer
     surprises when deploying an application.

  2. Tailoring their stack to their use-case. Avoid the complexity of running
     something like Kubernetes while you are scaling up, but *also* avoid the
     complexity of rewriting your infrastructure stack once you need it.

  3. Unified developer tooling across different programming languages, without
     the overhead of using something like Bazel.

  Its radically new model can bring many other advantages which depend
  on the exact use-cases.
  </details>

* **Software development**. We offer a wide range of software development
  services. Whether you need existence with existing projects, or want to create
  a new solution from scratch, we can help. We specialize in helping
  organizations avoid the trap of building overly complex systems that don't
  meet their needs.

* **Site Reliability Engineering (SRE)**. We can help with many infrastructure
  concerns, such as deployment, scaling, monitoring, troubleshooting analysing
  failure points in existing solutions. We offer this for any Linux-based
  technology stack.

--------------

We support open-source software development, and prefer to work on our projects
in the open. Some of our projects are:

* The public TVL [monorepo][depot], the **depot**, is a demonstration of the
  monorepo tooling we have been working on for the last couple of years.

  It contains many open-source projects, work by lots of international
  open-source contributors, and all public code of the company.

* [**Tvix**][tvix], a new implementation of Nix that is fully compatible with
  existing Nix code. Architectural differences between Nix and Tvix allow us to
  develop tooling that is better tailored to collaborative software development,
  and to develop domestic, high-quality solutions for CI/CD.

  We run a demonstration of some parts of Tvix online as [tvixbolt].

* [**Nixery**][nixery] is a service that lets users easily build and deploy
  ad-hoc container images from their software build definitions.

* Out of personal interest, we also develop free tools that help with learning
  the Russian language, such as [**Предложник**][predlozhnik].

--------------

Reach out to us at **contact@tvl.su** if you are interested in working with us.

TVL originated as an international community of software developers that wanted
to socialise and collaborate on projects. Many people from all over the world
contribute to our open-source software projects. Check out the [TVL community
website][tvl] for more information.

[tvl]: https://tvl.fyi
[tvix]: https://tvl.fyi/blog/rewriting-nix
[nixery]: https://nixery.dev
[predlozhnik]: https://predlozhnik.ru/
[depot]: https://cs.tvl.fyi/depot
